@echo off

::
:: This script deregisters uberAgent's IE browser helper objects (BHO) silently
::
:: Requirements:
::
:: - The following files must be present in the directory %ProgramFiles%\vast limits\uberAgent
::    - uAIEExtension32.dll
::    - uAIEExtension64.dll (optional)
::
:: Return values:
::
::    1-5  ->    regsvr32 internal error
::    6    ->    Required file uAIEExtension32 not found
::

if not exist "%ProgramFiles%\vast limits\uberAgent\uAIEExtension32.dll" (
   echo ERROR 32-bit uberAgent Internet Explorer add-on not found >&2
	exit /b 6
)

regsvr32 /s /u "%ProgramFiles%\vast limits\uberAgent\uAIEExtension32.dll"

if exist "%ProgramFiles%\vast limits\uberAgent\uAIEExtension64.dll" (
   regsvr32 /s /u "%ProgramFiles%\vast limits\uberAgent\uAIEExtension64.dll"
)


echo INFO ...done! >&2

exit /b %errorlevel%